<template>
  <VApp>
    <TheDrawer v-if="layout" />

    <TheHeader v-if="layout" />

    <VContent>
      <Nuxt v-if="!loading" />
    </VContent>

    <VFooter
      v-if="layout"
      color="primary"
      class="px-3 white--text"
      app
    >
      <small>Copyright © 2019 Leonardo C. Carvalho</small>
      <VSpacer />
      <small>Feito com muito amor <VIcon color="red">mdi-heart</VIcon></small>
    </VFooter>
  </VApp>
</template>

<script lang="ts">
import {
  Component, Vue, State, Mutation, Watch,
} from 'nuxt-property-decorator';

@Component({
  components: {
    TheDrawer: () => import('@/components/layouts/the-drawer.vue'),
    TheHeader: () => import('@/components/layouts/the-header.vue'),
  },
})
export default class Default extends Vue {
  @State
  dark!: boolean

  @State
  layout!: boolean

  @Mutation
  setLayout!: (key: boolean) => void

  loading = true

  async mounted() {
    await this.$nextTick();

    this.$nuxt.$loading.start();
    this.setLayout(true);
    this.loading = false;
    this.$vuetify.theme.dark = this.dark;
    this.$nuxt.$loading.finish();
  }

  @Watch('dark')
  changeTheme(bool: boolean) {
    this.$vuetify.theme.dark = this.dark;
  }
}
</script>
